/* 
 * File:   main.c
 * Author: m-sueishi
 *
 * Created on 2020/01/20, 14:52
 */
/////////////////////////////////////////////////////////////////////////////
//
//                        PIC12F1822
//                      +------------+
//                      |            |
//                 Vdd =| 1        8 |= Vss
//                      |            |
//        ADC_CS (RA5) =| 2        7 |= G96_CS (RA0) / ICSPDAT
//                      |            |
//          MOSI (RA4) =| 3        6 |= SCK (RA1)    / ICSPCLK
//                      |            |
//      Vpp /      RA3 =| 4        5 |= MISO (RA2)
//                      |            |
//                      +------------+
//
/////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>

#include <pic.h>
#include <htc.h> // delay?

// RtBM[V1̐ݒ
// CLKOUT݂RA4݂Ŏgp(CLKOUTEN_OFF)Fۯgp(FOSC_INTOSC)
// OۯĎȂ(FCMEN_OFF)FOEۯ̐ؑւł̋N͂Ȃ(IESO_OFF)
// dd~펞Ď@\ON(BOREN_ON)FdON64ms۸тJn(PWRTEN_ON)
// ޯϰ(WDTE_OFF)F
// OؾĐM͎gp޼ٓ(RA3)݂Ƃ(MCLRE_OFF)
// ۸ذی삵Ȃ(CP_OFF)Fްذی삵Ȃ(CPD_OFF)
#pragma config CPD = OFF, BOREN = ON, IESO = OFF, FOSC = INTOSC, FCMEN = OFF
#pragma config MCLRE = OFF, WDTE = OFF, CP = OFF, PWRTE = ON, CLKOUTEN = OFF

// RtBM[V2̐ݒ
// NbN4{œ삳(PLLEN_ON)
// X^bNI[ot[A_[t[烊Zbg(STVREN_ON)
// dvO~O@\gpȂ(LVP_OFF)
// Flashذی삵Ȃ(WRT_OFF)Fdd~펞Ďd(2.5V)ݒ(BORV_25)
#pragma config PLLEN = ON, STVREN = ON, WRT = OFF, BORV = LO, LVP = OFF

// delaypɕKv(NbN32MHzw)
#define _XTAL_FREQ 32000000

////////////////////////////////////////////////////////////
#define G96_CS       RA0
#define ADC_CS       RA5

//Reg
#define RADD   0x00
#define RENV1  0x02
#define RENV2  0x04
#define PORT   0x06
#define Tick   0x08
#define RSH0   0x0C
#define RSH1   0x0E
#define RSHR   0x10
#define RBCS   0x12
#define RIDN   0x14
//commanf
#define CDVON  0x10
#define CDVOF  0x11
//Memory addres(32d)
#define DEV32  0x80

// w肵(numx10ms)EGCgs֐
void Wait(unsigned int num)
{
    int i ;

    for (i=0 ; i<num ; i++)
    {
      __delay_ms(10) ;     // 10ms ꎞ~
    }
}

//initialize
void init(void)
{
    OSCCON = 0b01110000 ;     // 8MHz  4{ = 32MHz
    ANSELA = 0b00000000 ;     // AiO͎gpȂiׂăfW^I/OɊĂj
    TRISA  = 0b00001100 ;     // RA2sȊOSďo͂ɊĂ(RA3͓͐p)
    PORTA  = 0b00100001 ;     // o̓s̏(RA0(G96_CS)RA5(ADC_CS)HighAȊOLOW)

    // SPI[h̐ݒƏ
    SDOSEL   = 1 ;            // 1:RA4SDOsɐݒ / 0:RA0SDOsɐݒ
    SSSEL    = 1 ;            // 1:RA0SSsɐݒ / 0:RA3SSsɐݒ
    SSP1CON1 = 0b00110001 ;   // SPI(bit5)=1(Enables serial port and configures SCK, SDO, SDI and SS)
                              // CKP(bit4)=1(Idle state for clock is a high level)
                              // SPI Master mode
                              // clock = FOSC/16
    SSP1STAT = 0b00000000 ;   // CKE(bit6)=0(SPI Clock Edge Select bit)
    SSP1IF = 0 ;              // Interrupt is not pending
    SSP1IE = 1 ;              // SPI݂̊
    PEIE   = 1 ;              // ӑuݗL
    GIE    = 1 ;              // Sݏ
    SSP1BUF = 0;
}


/******************************
SPI_WriteRead
*******************************/
unsigned char SPI_WriteRead(unsigned char TransDat)
{
    SSP1BUF = TransDat;
    while(!BF){};//while(BF==0);

    return SSP1BUF;
}

/******************************
G9006 Status
*******************************/
void GetStatusG9006(unsigned char *read_1,
                      unsigned char *read_2
                 )
{
    //
    G96_CS = 0;
    SPI_WriteRead(0x30);//Status-Read command, Add=00
    *read_1 = SPI_WriteRead(0);//dumy
    *read_2 = SPI_WriteRead(0);//dumy
    G96_CS = 1;
}

/******************************
G9006 Get reg
*******************************/
void GetRegG9006(int RegNum,
                   unsigned char *read_1,
                   unsigned char *read_2
                 )
{
    //
    G96_CS = 0;
    SPI_WriteRead(0x10);//Reg-Read command, Add=00
    SPI_WriteRead(RegNum);//Address
    *read_1 = SPI_WriteRead(0);//dumy
    *read_2 = SPI_WriteRead(0);//dumy
    G96_CS = 1;
}

/******************************
G9006 Set reg
*******************************/
void SetRegG9006(int RegNum,
                   unsigned char write_1,
                   unsigned char write_2
                 )
{
    //
    G96_CS = 0;
    SPI_WriteRead(0x00);//Reg-Write command, Add=00
    SPI_WriteRead(RegNum);//Address
    SPI_WriteRead(write_1);//data
    SPI_WriteRead(write_2);//data
    G96_CS = 1;
}

/******************************
G9006 Set com
*******************************/
void SetComG9006(int Comm)
{
    //
    G96_CS = 0;
    SPI_WriteRead(0x20);//Command-Write, Add=00
    SPI_WriteRead(Comm);//command
    G96_CS = 1;
}

/******************************
G9006 Set Mem
*******************************/
void SetMemG9006(int MemAdd,
                   unsigned char write_1,
                   unsigned char write_2
                 )
{
    //
    G96_CS = 0;
    SPI_WriteRead(0x40);//PortArea-Write command, Add=00
    SPI_WriteRead(MemAdd);//Address
    SPI_WriteRead(write_1);//data
    SPI_WriteRead(write_2);//data
    G96_CS = 1;
}

/******************************
 * Get ADC
*******************************/
void GetADC(unsigned char *read_1,
             unsigned char *read_2
            )
{
    unsigned char dat_1, dat_2;
    //
    ADC_CS = 0;
    dat_1 = SPI_WriteRead(0x00);//dumy write
    dat_2 = SPI_WriteRead(0x00);//dumy write
    ADC_CS = 1;
    //
    *read_2 = (dat_1 >> 6) & 0x03;
    *read_1 = ((dat_1 << 2) & 0xFC) | ((dat_2 >> 6) & 0x03);
}

/*
 * 
 */
int main(int argc, char** argv)
{
    unsigned char dat_L, dat_H;
    int loops;
    union data
    {
        char Cdat[4];
        long Sdat;
    } sumdat, wkdat;
       
    //PIC initial
    init();
 
    Wait(22) ; //Wait G9006 reset end

    //G9006 initial
    SetRegG9006(RADD, 0x20, 0x03); // RADD=0x0320
                                  //  DN = 32d(20h)
                                  //  MONI = 0
                                  //  PMD = 03h
                                  //  RSV = 0
    SetComG9006(CDVON);//start
   
    GetRegG9006(RADD, &dat_L, &dat_H);
    GetRegG9006(RIDN, &dat_L, &dat_H);
    GetStatusG9006(&dat_L, &dat_H);
   
    //
    while(1)
    {
        //Read ADC
        sumdat.Sdat = 0;
        for(loops = 0; loops < 64; loops++)//TvOϒlgp
        {
            GetADC(&dat_L, &dat_H);
            wkdat.Cdat[0] = dat_L;
            wkdat.Cdat[1] = dat_H;
            wkdat.Cdat[2] = 0;
            wkdat.Cdat[3] = 0;
            sumdat.Sdat = sumdat.Sdat + wkdat.Sdat;
            __delay_us(8);
        }
        sumdat.Sdat = (sumdat.Sdat >> 6);
        //Set G9006-port
        SetMemG9006(DEV32, sumdat.Cdat[0], sumdat.Cdat[1]);    
    }

    //return (EXIT_SUCCESS);
}

